<template>
  <aside class="filter">
    <h2 class="filter__title">Фильтры</h2>

    <form class="filter__form form" action="#" method="get">
      <fieldset class="form__block">
        <legend class="form__legend">Цена</legend>
        <label class="form__label form__label--price">
          <input class="form__input" type="text" name="min-price" v-model.number="currentPriceFrom">
          <span class="form__value">От</span>
        </label>
        <label class="form__label form__label--price">
          <input class="form__input" type="text" name="max-price" v-model.number="currentPriceTo">
          <span class="form__value">До</span>
        </label>
      </fieldset>

      <fieldset class="form__block">
        <legend class="form__legend">Категория</legend>
        <label class="form__label form__label--select">
          <select class="form__select" type="text" v-model.number="currentCategoryId">
            <option value="0">Все категории</option>
            <option :value="category.id" v-for="category in categories" :key="category.id">
              {{ category.name }}
            </option>
          </select>
        </label>
      </fieldset>

      <fieldset class="form__block">
        <legend class="form__legend">Цвет</legend>
        <color-choices :colors="availableColors" :color.sync="currentColor"/>
      </fieldset>

      <fieldset class="form__block">
        <legend class="form__legend">Объемб в ГБ</legend>
        <ul class="check-list">
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="8"
                     checked="">
              <span class="check-list__desc">
                    8
                    <span>(313)</span>
                  </span>
            </label>
          </li>
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="16">
              <span class="check-list__desc">
                    16
                    <span>(461)</span>
                  </span>
            </label>
          </li>
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="32">
              <span class="check-list__desc">
                    32
                    <span>(313)</span>
                  </span>
            </label>
          </li>
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="64">
              <span class="check-list__desc">
                    64
                    <span>(313)</span>
                  </span>
            </label>
          </li>
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="128">
              <span class="check-list__desc">
                    128
                    <span>(313)</span>
                  </span>
            </label>
          </li>
          <li class="check-list__item">
            <label class="check-list__label">
              <input class="check-list__check sr-only" type="checkbox" name="volume" value="264">
              <span class="check-list__desc">
                    264
                    <span>(313)</span>
                  </span>
            </label>
          </li>
        </ul>
      </fieldset>

      <button class="filter__submit button button--primery" type="submit"
              @click.prevent="applyFilters()">
        Применить
      </button>
      <button class="filter__reset button button--second" type="button"
              @click.prevent="resetFilters()"
      >
        Сбросить
      </button>
    </form>
  </aside>
</template>

<script>
import categories from '@/data/categories';
import ColorChoices from '@/components/helpers/ColorChoices.vue';

export default {
  name: 'ItemFilter',
  components: { ColorChoices },
  props: ['filterData', 'availableColors'],
  data() {
    return {
      categories,
      currentPriceFrom: 0,
      currentPriceTo: 0,
      currentCategoryId: 0,
      currentColor: null,
    };
  },
  watch: {
    filterData(value) {
      this.currentPriceFrom = value.priceFrom;
      this.currentPriceTo = value.priceTo;
      this.currentCategoryId = value.categoryId;
      this.currentColor = value.color;
    },
  },
  methods: {
    setColor(value) {
      this.currentColor = value;
    },
    applyFilters() {
      this.$emit('update:filterData', {
        priceFrom: this.currentPriceFrom,
        priceTo: this.currentPriceTo,
        categoryId: this.currentCategoryId,
        color: this.currentColor,
      });
    },
    resetFilters() {
      this.$emit('update:filterData', {
        priceFrom: 0,
        priceTo: 0,
        categoryId: 0,
        color: null,
      });
    },
  },
};
</script>

<style scoped>

</style>
